' ****************************************************************
' Funktion:     Kopiert alle Office-Add-ins (mit Endung ".dotm")
'               aus dem Ordner dieses Skripts in den AutoStart-
'               Ordner von Word. mstv2007.dotm wird achiviert.
' Autor:				Wilhelm Happe, 2011
' ****************************************************************

Option Explicit
Dim objWS, objFSO, objShell
Dim objQuellOrdner, objDatei, objZielOrdner, objMSTVOrig, objWMIService, colProcessList
Dim intZaehler, strQuellOrdner, strExtension, strZielOrdner, strMSTVOrig, strWert, strDotm
On Error Resume Next
Set objWS = CreateObject("WScript.Shell")
Set objFSO = CreateObject("Scripting.FileSystemObject")
Set objShell = CreateObject("Shell.Application")

'Zhler initialisieren
intZaehler = 0
'Pfad des Skripts aus dessen Pfadnamen isolieren
strQuellOrdner = Left(WScript.ScriptFullName, InstrRev(WScript.ScriptFullName, "\") - 1)
'Verweis auf Quellordner holen
Set objQuellOrdner = objFSO.GetFolder(strQuellOrdner)

'Wenn Word aktiv ist, knnen die Vorlagedateien nicht kopiert werden.
Set objWMIService = GetObject("winmgmts:" _
	& "{impersonationLevel=impersonate}!\\.\root\cimv2")
Set colProcessList = objWMIService.ExecQuery _
	("SELECT * FROM Win32_Process WHERE Name = 'winword.exe'")
If colProcessList.Count > 0 Then
	MsgBox "Sie mssen zunchst Word beenden!", vbCritical, WScript.ScriptName
	Wscript.Quit
End If
Set objWMIService = Nothing
Set colProcessList  = Nothing

'... Zielordnerpfad auf AutoStart-Ordner von Word einstellen
'Der Registry-Schlssel 'STARTUP-PATH' existiert nur, wenn der Pfad manuell gendert wurde.
strWert = objWS.RegRead("HKCR\Word.Application\CurVer\")
strWert = Mid(strWert, InStrRev(strWert, ".", -1) + 1) & ".0"
strWert = "HKCU\Software\Microsoft\Office\" & strWert & "\Word\Options\STARTUP-PATH"
strZielOrdner = objWS.RegRead(strWert)
If Err.Number <> 0 Then
	strZielOrdner = objWS.SpecialFolders("AppData") & "\Microsoft\Word\STARTUP"
End If
Err.Clear
If strZielOrdner > "" Then
	If Not objFSO.FolderExists(strZielOrdner) Then
		MsgBox "Der Zielpfad 'Word-AutoStart-Ordner' wurde nicht gefunden!" & vbCr & _
		"Die Pfadangaben im Skript sind mglichweise falsch.", vbCritical, WScript.ScriptName
		Wscript.Quit
	Else
    For Each objDatei In objQuellOrdner.Files
    	strExtension = LCase(objFSO.GetExtensionName(objDatei.Name))
      Select Case strExtension
    		Case "dotm"
          strDotm = strDotm & " " & objDatei.Name & vbCr
      End Select
    Next
	  If MsgBox(strDotm & vbCr & "Mchten Sie die Dateien in den folgenden Ordner kopieren?" & _
    vbCr & strZielOrdner, vbQuestion + vbYesNo, WScript.ScriptName) = vbNo Then
			Wscript.Quit
		Else
			'... Verweis auf Zielordner holen
			Set objZielOrdner = objShell.NameSpace(strZielOrdner)
   	End If
 	End If
End If

'Original-MEDISTAR-Makrodatei archivieren
strMSTVOrig = strZielOrdner & "\mstv2007.dotm"
If objFSO.FileExists(strMSTVOrig) Then
  MsgBox "'" & strMSTVOrig & "' ist vorhanden." & vbCr & vbCr & _
	"Die Datei wird umbenannt (Endung 'original').", vbExclamation, WScript.ScriptName
	Set objMSTVOrig = objFSO.GetFile(strMSTVOrig)
  ' Gegebenenfalls Schreibschutz entfernen
	If (objMSTVOrig.Attributes And 32) Then
  	objMSTVOrig.Attributes = objMSTVOrig.Attributes And Not 32
	End If
	strMSTVOrig = Left(strMSTVOrig, InStrRev(strMSTVOrig, ".") - 1) & ".original"
	objMSTVOrig.Copy strMSTVOrig
 	If Err > 0 Then
    MsgBox "Fehler beim Umbenennen der Datei '" & objMSTVOrig.Name & "':" & vbCr & _
		Err.Description, vbCritical, WScript.ScriptName
	Else
		objMSTVOrig.Delete
  End If
 	Err.Clear
End If

'Alle Dateien des Quellordners durchlaufen
For Each objDatei In objQuellOrdner.Files
	'Dateiextension isolieren (in Kleinbuchstaben)
	strExtension = LCase(objFSO.GetExtensionName(objDatei.Name))
  Select Case strExtension
   	'Im Fall eines Word-Add-ins... (ab 2007)
		Case "dotm"
		' Datei kopieren. 16 = ohne Nachfrage berschreiben
    objZielOrdner.CopyHere objDatei.Path, 16
    'Wenn dabei kein Fehler auftritt, dann...
    If Err = 0 Then
      '... Zhler erhhen
      intZaehler = intZaehler + 1
    Else
      MsgBox "Fehler beim Kopieren der Datei '" & objDatei.Name & "':" & vbCr & _
				Err.Description, vbCritical, WScript.ScriptName
    End If
    Err.Clear
  End Select
Next

'Erfolgsmeldung ausgeben
If intZaehler = 0 Then
	MsgBox  "Es wurden keine Word-Vorlagedateien gefunden. Die Dateien " & _
	"mssen sich im selben Ordner wie " & WScript.ScriptName & " befinden.", vbCritical, WScript.ScriptName
Else
	MsgBox  "Fertig!" & vbCr & _
	intZaehler & " Datei(en) wurden erfolgreich kopiert.", vbInformation, WScript.ScriptName
End If