'*************************************************************
' Funktion:    Aktiviert oder deaktiviert MEDISTAR-Wordmakros
'              durch nderung der Dateiendung ("DOTM"/"DOT-")
' Autor:			 Wilhelm Happe, 2012
'*************************************************************
Option Explicit
On Error Resume Next
Dim objWS, objFSO
Dim strValue, strStartupFolder, dlgAnswer, toggleDOT, dsbldDOT
''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
toggleDOT = "MSTV2007.dotm"  ' Bitte individuell anpassen!
''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
Set objWS = CreateObject("WScript.Shell")
Set objFSO = CreateObject("Scripting.FileSystemObject")

dsbldDOT = objFSO.GetBaseName(toggleDOT) & ".dot-"

'... Zielordnerpfad auf AutoStart-Ordner von Word einstellen
'Der Registry-Schlssel 'STARTUP-PATH' existiert nur, wenn der Pfad manuell gendert wurde.
strValue = objWS.RegRead("HKCR\Word.Application\CurVer\")
strValue = Mid(strValue, InStrRev(strValue, ".", -1) + 1) & ".0"
strValue = "HKCU\Software\Microsoft\Office\" & strValue & "\Word\Options\STARTUP-PATH"
strStartupFolder = objWS.RegRead(strValue)
If Err.Number <> 0 Then
	strStartupFolder = objWS.SpecialFolders("AppData") & "\Microsoft\Word\StartUp"
'C:\Dokumente und Einstellungen\Praxis\Anwendungsdaten\Microsoft\Word\StartUp
End If
Err.Clear

If strStartupFolder > "" Then
  objWS.CurrentDirectory = strStartupFolder
	If Not objFSO.FolderExists(strStartupFolder) Then
		MsgBox "Der 'Startup-Ordner' wurde nicht gefunden!", vbCritical, _
      WScript.ScriptName
		Wscript.Quit
	ElseIf (objFSO.FileExists(toggleDOT) Or objFSO.FileExists(dsbldDOT)) Then
    dlgAnswer = MsgBox("Mchten Sie die '" & toggleDOT & "' aktivieren?" & _
      vbCr & "Whlen Sie Nein, um die MEDISTAR-Wordmakros" & vbCr &_
      "zu deaktivieren (DOTM-Datei erhlt Endung 'DOT-').", _
      vbYesNoCancel + vbQuestion, strStartupFolder)
    If dlgAnswer = vbYes Then
      objFSO.CopyFile dsbldDOT, toggleDOT, True
      If Err <> 0 Then
        MsgBox "Es ist keine Aktion erforderlich, da '" & toggleDOT & _
          "' bereits vorhanden ist!" &  vbCr & _
          "('" & dsbldDOT & "' wurde korrekterweise nicht gefunden.)", _
          vbCritical, "MEDISTAR-Wordmakros aktivieren"
      Else
        objFSO.DeleteFile dsbldDOT
        If Err <> 0 Then
          MsgBox "Fehler beim Lschen der Datei '" & dsbldDOT & "':" & vbCr & _
           Err.Description, vbCritical, WScript.ScriptName
        Else
          MsgBox "Fertig! '" & toggleDOT & "' wurde aktiviert.", vbInformation, _
            WScript.ScriptName
        End If
      End If
    ElseIf dlgAnswer = vbNo Then
      objFSO.CopyFile toggleDOT, dsbldDOT, True
      If Err <> 0 Then
        MsgBox "Es ist keine Aktion erforderlich, da '" & dsbldDOT & _
          "' bereits vorhanden ist!" &  vbCr & _
          "('" & toggleDOT & "' wurde korrekterweise nicht gefunden.)", _
          vbCritical, "MEDISTAR-Wordmakros deaktivieren"
      Else
        objFSO.DeleteFile toggleDOT
        If Err <> 0 Then
          MsgBox "Fehler beim Lschen der Datei '" & toggleDOT & "':" & vbCr & _
           Err.Description, vbCritical, WScript.ScriptName
        Else
          MsgBox "Fertig! '" & toggleDOT & "' wurde deaktiviert.", _
            vbInformation, WScript.ScriptName
        End If
      End If
    End If
  Else
    dlgAnswer = MsgBox("'" & toggleDOT & "' bzw. '" & dsbldDOT & "'" & vbCr &_
      " wurden nicht gefunden!" & vbCr & vbCr & _
      "Der Startup-Ordner wird nun im Explorer angezeigt." & vbCr &_
      "Kontrollieren Sie den Dateinamen und ndern Sie das Skript.", _
      vbOKCancel + vbInformation, WScript.ScriptName)
    If dlgAnswer = vbOK Then
      Const dbQuote = """"
      Err.Clear
      objWS.Run(dbQuote & strStartupFolder & dbQuote)
      If Err.Number <> 0 Then
    	  MsgBox Err.Description, vbCritical, WScript.ScriptName
      End If
    End If
  End If
End If
